#include <stdio.h>
#include "gfx.h"
#include "mem.h"
#include "mz80.h"
#include "yaame.h"

unsigned char intenable;

static void writeint(UINT32 addr, UINT8 data, struct MemoryWriteByte *pMemWrite)
{
        intenable=data;
}

struct MemoryWriteByte kongwrite[] =
{
        {0,0x4000,writerom},
        {0x7D84,0x7D84,writeint},
        {-1,-1,NULL}
};

UINT8 readkongin0(UINT32 addr, struct MemoryReadByte *crap)
{
        unsigned char temp=0;
        if (keys[KEY_DOWN])
           temp|=8;
        if (keys[KEY_UP])
           temp|=4;
        if (keys[KEY_LEFT])
           temp|=2;
        if (keys[KEY_RIGHT])
           temp|=1;
        if (keys[KEY_SPACE])
           temp|=16;
        return temp;
}

UINT8 readkongin1(UINT32 addr, struct MemoryReadByte *crap)
{
        return 0;
}

UINT8 readkongin2(UINT32 addr, struct MemoryReadByte *crap)
{
        unsigned char temp=0;
        if (keys[KEY_C])
           temp|=128;
        if (keys[KEY_1])
           temp|=4;
        return temp;
}

UINT8 readkongdsw1(UINT32 addr, struct MemoryReadByte *crap)
{
        return 0x84;
}

struct MemoryReadByte kongread[] =
{
        {0x7C00,0x7C7F,readkongin0},
        {0x7C80,0x7CFF,readkongin1},
        {0x7D00,0x7D7F,readkongin2},
        {0x7D80,0x7DFF,readkongdsw1},
        {-1,-1,NULL}
};

struct z80PortRead kongportread[] =
{
	{-1,	  -1,	  NULL}
};

struct z80PortWrite kongportwrite[] =
{
	{-1,	-1,	NULL}
};

static unsigned char dkongpal[] =
{
	/* 2k - palette low 4 bits (inverted) */
	0xFF,0xFC,0xF0,0xFF,0xFF,0xFB,0xFF,0xF0,0xFF,0xFA,0xFF,0xFD,0xFF,0xFC,0xFF,0xF3,
	0xFF,0xF3,0xFB,0xFF,0xFF,0xF0,0xFD,0xF3,0xFF,0xFF,0xFC,0xF0,0xFF,0xFF,0xFA,0xF0,
	0xFF,0xFF,0xFA,0xF3,0xFF,0xF0,0xF3,0xF5,0xFF,0xFD,0xF0,0xF5,0xFF,0xFC,0xF3,0xFA,
	0xFF,0xF0,0xF0,0xFC,0xFF,0xFF,0xFB,0xF3,0xFF,0xFE,0xFA,0xFC,0xFF,0xFB,0xFF,0xFF,
	0xFF,0xFC,0xF0,0xFF,0xFF,0xFB,0xFF,0xF0,0xFF,0xFA,0xFF,0xFD,0xFF,0xF3,0xFA,0xF0,
	0xFF,0xF3,0xFA,0xF0,0xFF,0xF3,0xFA,0xF0,0xFF,0xF3,0xFA,0xF0,0xFF,0xFF,0xFA,0xF0,
	0xFF,0xFF,0xFA,0xF3,0xFF,0xF0,0xF3,0xF5,0xFF,0xFD,0xF0,0xF5,0xFF,0xFC,0xF3,0xFA,
	0xFF,0xF0,0xF0,0xFC,0xFF,0xFF,0xFB,0xF3,0xFF,0xFE,0xFA,0xFC,0xFF,0xFB,0xFF,0xFF,
	0xFF,0xFC,0xF0,0xFF,0xFF,0xFB,0xFF,0xF0,0xFF,0xFA,0xFF,0xFD,0xFF,0xFA,0xFF,0xF0,
	0xFF,0xFA,0xFF,0xF0,0xFF,0xFA,0xFF,0xF0,0xFF,0xFA,0xFF,0xF0,0xFF,0xFF,0xFA,0xF0,
	0xFF,0xFF,0xFA,0xF3,0xFF,0xF0,0xF3,0xF5,0xFF,0xFD,0xF0,0xF5,0xFF,0xFC,0xF3,0xFA,
	0xFF,0xF0,0xF0,0xFC,0xFF,0xFF,0xFB,0xF3,0xFF,0xFE,0xFA,0xFC,0xFF,0xFB,0xFF,0xFF,
	0xFF,0xFC,0xF0,0xFF,0xFF,0xFB,0xFF,0xF0,0xFF,0xFA,0xFF,0xFD,0xFF,0xFC,0xF0,0xFB,
	0xFF,0xFC,0xF0,0xFB,0xFF,0xFC,0xF0,0xFB,0xFF,0xFC,0xF0,0xFB,0xFF,0xFF,0xFA,0xF0,
	0xFF,0xFF,0xFA,0xF3,0xFF,0xF0,0xF3,0xF5,0xFF,0xFD,0xF0,0xF5,0xFF,0xFC,0xF3,0xFA,
	0xFF,0xF0,0xF0,0xFC,0xFF,0xFF,0xFB,0xF3,0xFF,0xFE,0xFA,0xFC,0xFF,0xFB,0xFF,0xFF,
	/* 2j - palette high 4 bits (inverted) */
	0xFF,0xF6,0xFE,0xF1,0xFF,0xF0,0xF1,0xF0,0xFF,0xF0,0xF1,0xFF,0xFF,0xFF,0xF1,0xFE,
	0xFF,0xF1,0xF0,0xF1,0xFF,0xF0,0xF1,0xF0,0xFF,0xF1,0xFF,0xFE,0xFF,0xF5,0xF0,0xF0,
	0xFF,0xF5,0xF0,0xF1,0xFF,0xF0,0xF1,0xF1,0xFF,0xFF,0xF0,0xF1,0xFF,0xFF,0xF1,0xF0,
	0xFF,0xF0,0xFE,0xFF,0xFF,0xF1,0xF0,0xF1,0xFF,0xF2,0xF0,0xFF,0xFF,0xF0,0xF1,0xFF,
	0xFF,0xF6,0xFE,0xF1,0xFF,0xF0,0xF1,0xF0,0xFF,0xF0,0xF1,0xFF,0xFF,0xF1,0xF0,0xF0,
	0xFF,0xF1,0xF0,0xF0,0xFF,0xF1,0xF0,0xF0,0xFF,0xF1,0xF0,0xF0,0xFF,0xF5,0xF0,0xF0,
	0xFF,0xF5,0xF0,0xF1,0xFF,0xF0,0xF1,0xF1,0xFF,0xFF,0xF0,0xF1,0xFF,0xFF,0xF1,0xF0,
	0xFF,0xF0,0xFE,0xFF,0xFF,0xF1,0xF0,0xF1,0xFF,0xF2,0xF0,0xFF,0xFF,0xF0,0xF1,0xFF,
	0xFF,0xF6,0xFE,0xF1,0xFF,0xF0,0xF1,0xF0,0xFF,0xF0,0xF1,0xFF,0xFF,0xF1,0xF7,0xFE,
	0xFF,0xF1,0xF7,0xFE,0xFF,0xF1,0xF7,0xFE,0xFF,0xF1,0xF7,0xFE,0xFF,0xF5,0xF0,0xF0,
	0xFF,0xF5,0xF0,0xF1,0xFF,0xF0,0xF1,0xF1,0xFF,0xFF,0xF0,0xF1,0xFF,0xFF,0xF1,0xF0,
	0xFF,0xF0,0xFE,0xFF,0xFF,0xF1,0xF0,0xF1,0xFF,0xF2,0xF0,0xFF,0xFF,0xF0,0xF1,0xFF,
	0xFF,0xF6,0xFE,0xF1,0xFF,0xF0,0xF1,0xF0,0xFF,0xF0,0xF1,0xFF,0xFF,0xFF,0xFE,0xF0,
	0xFF,0xFF,0xFE,0xF0,0xFF,0xFF,0xFE,0xF0,0xFF,0xFF,0xFE,0xF0,0xFF,0xF5,0xF0,0xF0,
	0xFF,0xF5,0xF0,0xF1,0xFF,0xF0,0xF1,0xF1,0xFF,0xFF,0xF0,0xF1,0xFF,0xFF,0xF1,0xF0,
	0xFF,0xF0,0xFE,0xFF,0xFF,0xF1,0xF0,0xF1,0xFF,0xF2,0xF0,0xFF,0xFF,0xF0,0xF1,0xFF,
	/* 5f - character color codes on a per-column basis */
	0xF0,0xF1,0xF1,0xF2,0xF6,0xF6,0xF4,0xF6,0xF6,0xF6,0xF6,0xF3,0xF6,0xF3,0xF4,0xF3,
	0xF6,0xF6,0xF6,0xF6,0xF4,0xF3,0xF4,0xF5,0xF4,0xF6,0xF5,0xF3,0xF5,0xF3,0xF6,0xF3,
	0xF0,0xF1,0xF1,0xF2,0xF6,0xF6,0xF4,0xF6,0xF6,0xF6,0xF6,0xF3,0xF6,0xF3,0xF4,0xF3,
	0xF6,0xF6,0xF6,0xF6,0xF4,0xF3,0xF4,0xF5,0xF4,0xF6,0xF5,0xF3,0xF5,0xF3,0xF6,0xF3,
	0xF0,0xF1,0xF1,0xF2,0xF6,0xF6,0xF4,0xF6,0xF6,0xF6,0xF6,0xF3,0xF6,0xF3,0xF4,0xF3,
	0xF6,0xF6,0xF6,0xF6,0xF4,0xF3,0xF4,0xF5,0xF4,0xF6,0xF5,0xF3,0xF5,0xF3,0xF6,0xF3,
	0xF0,0xF1,0xF1,0xF2,0xF6,0xF6,0xF4,0xF6,0xF6,0xF6,0xF6,0xF3,0xF6,0xF3,0xF4,0xF3,
	0xF6,0xF6,0xF6,0xF6,0xF4,0xF3,0xF4,0xF5,0xF4,0xF6,0xF5,0xF3,0xF5,0xF3,0xF6,0xF3,
	0xF0,0xF1,0xF1,0xF2,0xF6,0xF6,0xF4,0xF6,0xF6,0xF6,0xF6,0xF3,0xF6,0xF3,0xF4,0xF3,
	0xF6,0xF6,0xF6,0xF6,0xF4,0xF3,0xF4,0xF5,0xF4,0xF6,0xF5,0xF3,0xF5,0xF3,0xF6,0xF3,
	0xF0,0xF1,0xF1,0xF2,0xF6,0xF6,0xF4,0xF6,0xF6,0xF6,0xF6,0xF3,0xF6,0xF3,0xF4,0xF3,
	0xF6,0xF6,0xF6,0xF6,0xF4,0xF3,0xF4,0xF5,0xF4,0xF6,0xF5,0xF3,0xF5,0xF3,0xF6,0xF3,
	0xF0,0xF1,0xF1,0xF2,0xF6,0xF6,0xF4,0xF6,0xF6,0xF6,0xF6,0xF3,0xF6,0xF3,0xF4,0xF3,
	0xF6,0xF6,0xF6,0xF6,0xF4,0xF3,0xF4,0xF5,0xF4,0xF6,0xF5,0xF3,0xF5,0xF3,0xF6,0xF3,
	0xF0,0xF1,0xF1,0xF2,0xF6,0xF6,0xF4,0xF6,0xF6,0xF6,0xF6,0xF3,0xF6,0xF3,0xF4,0xF3,
	0xF6,0xF6,0xF6,0xF6,0xF4,0xF3,0xF4,0xF5,0xF4,0xF6,0xF5,0xF3,0xF5,0xF3,0xF6,0xF3
};

int kongloadgfx()
{
        FILE *f,*ff;
        int x,y,c;
        unsigned char temp;
        unsigned char byte1,byte2;
        buffer=createbmp(512,512);
        clearall(buffer,0);
        f=fopen("dk.3n","rb");
        ff=fopen("dk.3p","rb");
        for (c=0;c<256;c++)
        {
                for (y=7;y>-1;y--)
                {
                        bitplane[1][c][y]=getc(f);
                        bitplane[0][c][y]=getc(ff);
                }
        }
        fclose(ff);
        fclose(f);
        f=fopen("dk.7c","rb");
        ff=fopen("dk.7e","rb");
        for (c=0;c<256;c++)
        {
                for (y=7;y>-1;y--)
                {
                        bitplane[1][c+256][y]=getc(f);
                        bitplane[0][c+256][y]=getc(ff);
                }
        }
        fclose(ff);
        fclose(f);
        f=fopen("dk.7d","rb");
        ff=fopen("dk.7f","rb");
        for (c=0;c<256;c++)
        {
                for (y=7;y>-1;y--)
                {
                        bitplane[1][c+512][y]=getc(f);
                        bitplane[0][c+512][y]=getc(ff);
                }
        }
        fclose(ff);
        fclose(f);
	for (c = 0;c < 256;c++)
	{
		int bit0,bit1,bit2;


		/* red component */
		bit0 = (dkongpal[c+256] >> 1) & 1;
		bit1 = (dkongpal[c+256] >> 2) & 1;
		bit2 = (dkongpal[c+256] >> 3) & 1;
		yaamepal[c].r = 255 - (0x21 * bit0 + 0x47 * bit1 + 0x97 * bit2);
		/* green component */
		bit0 = (dkongpal[c] >> 2) & 1;
		bit1 = (dkongpal[c] >> 3) & 1;
		bit2 = (dkongpal[c+256] >> 0) & 1;
		yaamepal[c].g = 255 - (0x21 * bit0 + 0x47 * bit1 + 0x97 * bit2);
		/* blue component */
		bit0 = (dkongpal[c] >> 0) & 1;
		bit1 = (dkongpal[c] >> 1) & 1;
		yaamepal[c].b = 255 - (0x55 * bit0 + 0xaa * bit1);
                yaamepal[c].r/=4;
                yaamepal[c].g/=4;
                yaamepal[c].b/=4;
	}
}

int radarscopeloadgfx()
{
        FILE *f,*ff;
        int x,y,c;
        unsigned char temp;
        unsigned char byte1,byte2;
        buffer=createbmp(512,512);
        clearall(buffer,0);
        f=fopen("trs2v3hc","rb");
        ff=fopen("trs2v3gc","rb");
        for (c=0;c<256;c++)
        {
                for (y=7;y>-1;y--)
                {
                        bitplane[1][c][y]=getc(f);
                        bitplane[0][c][y]=getc(ff);
                }
        }
        fclose(ff);
        fclose(f);
        f=fopen("trs2v3dc","rb");
        ff=fopen("trs2v3cc","rb");
        for (c=0;c<256;c++)
        {
                for (y=7;y>-1;y--)
                {
                        bitplane[1][c+256][y]=getc(f);
                        bitplane[0][c+256][y]=getc(ff);
                }
        }
        fclose(ff);
        fclose(f);
        f=fopen("trs2v3bc","rb");
        ff=fopen("trs2v3ac","rb");
        for (c=0;c<256;c++)
        {
                for (y=7;y>-1;y--)
                {
                        bitplane[1][c+512][y]=getc(f);
                        bitplane[0][c+512][y]=getc(ff);
                }
        }
        fclose(ff);
        fclose(f);
	for (c = 0;c < 256;c++)
	{
		int bit0,bit1,bit2;


		/* red component */
		bit0 = (dkongpal[c+256] >> 1) & 1;
		bit1 = (dkongpal[c+256] >> 2) & 1;
		bit2 = (dkongpal[c+256] >> 3) & 1;
		yaamepal[c].r = 255 - (0x21 * bit0 + 0x47 * bit1 + 0x97 * bit2);
		/* green component */
		bit0 = (dkongpal[c] >> 2) & 1;
		bit1 = (dkongpal[c] >> 3) & 1;
		bit2 = (dkongpal[c+256] >> 0) & 1;
		yaamepal[c].g = 255 - (0x21 * bit0 + 0x47 * bit1 + 0x97 * bit2);
		/* blue component */
		bit0 = (dkongpal[c] >> 0) & 1;
		bit1 = (dkongpal[c] >> 1) & 1;
		yaamepal[c].b = 255 - (0x55 * bit0 + 0xaa * bit1);
                yaamepal[c].r/=4;
                yaamepal[c].g/=4;
                yaamepal[c].b/=4;
	}
}

int konginit()
{
        FILE *f;
        printf("Loading Donkey Kong ROMs\n");
        loadrom("dk.5e",0,4096);
        loadrom("dk.5c",0x1000,4096);
        loadrom("dk.5b",0x2000,4096);
        loadrom("dk.5a",0x3000,4096);
        kongloadgfx();
        initz80(kongread,kongwrite,kongportread,kongportwrite);
        printf("Donkey Kong loaded\n");
        return 0;
}

int radarscopeinit()
{
        FILE *f;
        printf("Loading Radar Scope ROMs\n");
        loadrom("trs2c5fc",0,4096);
        loadrom("trs2c5gc",0x1000,4096);
        loadrom("trs2c5hc",0x2000,4096);
        loadrom("trs2c5kc",0x3000,4096);
	ram[0x1E9C]=0xC3;
	ram[0x1E9D]=0xBD;
        radarscopeloadgfx();
        initz80(kongread,kongwrite,kongportread,kongportwrite);
        printf("Radar Scope loaded\n");
        return 0;
}

inline void draw8x8sprite(int tile, unsigned char x, unsigned char y, unsigned char colset, int xflip)
{
        int xx,yy;
        unsigned char byte1,byte2;
        if (!xflip)
        {
                for (yy=0;yy<8;yy++)
                {
                        byte2=bitplane[0][tile][yy];
                        byte1=bitplane[1][tile][yy];
                        for (xx=7;xx>-1;xx--)
                        {
                                if (((byte1&1)|((byte2&1)<<1)|(colset<<2))&3)
                                   buffer->line[xx+y][x+yy]=(byte1&1)|((byte2&1)<<1)|(colset<<2);
                                byte1>>=1;
                                byte2>>=1;
                        }
                }
        }
        else
        {
                for (yy=0;yy<8;yy++)
                {
                        byte2=bitplane[0][tile][7-yy];
                        byte1=bitplane[1][tile][7-yy];
                        for (xx=7;xx>-1;xx--)
                        {
                                if (((byte1&1)|((byte2&1)<<1)|(colset<<2))&3)
                                   buffer->line[xx+y][x+yy]=(byte1&1)|((byte2&1)<<1)|(colset<<2);
                                byte1>>=1;
                                byte2>>=1;
                        }
                }
        }
}

void kongdraw()
{
        int c,x,y,pos=0x7400,tile,xflip,colset;
        for (x=0;x<32;x++)
        {
                for (y=0;y<32;y++)
                {
                        drawtile(ram[pos++],(31-x)*8,y*8,colset);
                }
        }
        for (c=0;c<80;c++)
        {
                y=ram[0x6900+(c<<2)+3]-8;
                x=ram[0x6900+(c<<2)]-7;
                if (x>0&&y>0)
                {
                        tile=(ram[0x6900+(c<<2)+1]&0x7F)*2;
                        xflip=ram[0x6900+(c<<2)+1]&0x80;
                        colset=ram[0x6900+(c<<2)+2]&0xF;
                        if (!xflip)
                        {
                                draw8x8sprite(tile+257,x,y,colset,xflip);
                                draw8x8sprite(tile+256,x+8,y,colset,xflip);
                                draw8x8sprite(tile+513,x,y+8,colset,xflip);
                                draw8x8sprite(tile+512,x+8,y+8,colset,xflip);
                        }
                        else
                        {
                                draw8x8sprite(tile+256,x,y,colset,xflip);
                                draw8x8sprite(tile+257,x+8,y,colset,xflip);
                                draw8x8sprite(tile+512,x,y+8,colset,xflip);
                                draw8x8sprite(tile+513,x+8,y+8,colset,xflip);
                        }
                }
        }
        waitforsync();
        blit(buffer,screen,0,0,0,0,256,256);
}

void kongrun()
{
        FILE *f;
//        closegfx();
        while (!keys[KEY_ESC])
        {
                if (mz80exec(50000)!=0x80000000)
                {
                        closegfx();
                        printf("It crashed\n");
                        exit(-1);
                }
                if (intenable)
                   mz80nmi();
                kongdraw();
        }
        f=fopen("kong.dmp","wb");
        fwrite(ram+0x7400,0x400,1,f);
        fclose(f);
}
