#include <stdio.h>
#include <tomgfx.h>
#include "mem.h"
#include "mz80.h"

static struct mz80context z80;
unsigned char vidcon,vidscroll,sounda,soundb,dipswitch;
BMP *chars[2],*buffer;
unsigned char introutine;
int intenable;

static void writerom(UINT32 addr, UINT8 data, struct MemoryWriteByte *pMemWrite)
{
}

static void pacintenable(UINT32 addr, UINT8 data, struct MemoryWriteByte *pMemWrite)
{
/*        if (data)
        {
                closegfx();
                printf("ints on\n");
                exit(-1);
        }*/
        intenable=data;
}

UINT8 readpacin0(UINT32 addr, struct MemoryReadByte *crap)
{
        return 0xFF;
}

UINT8 readpacin1(UINT32 addr, struct MemoryReadByte *crap)
{
        return 0xFF;
}

UINT8 readpacin2(UINT32 addr, struct MemoryReadByte *crap)
{
        return 0xE9;
}


struct MemoryWriteByte pacmanwrite[] =
{
        {0,0x4000,writerom},
	{0x5000,0x5000,pacintenable},
        {-1,     -1,     NULL}
};

struct MemoryReadByte pacmanread[] =
{
        {0x5000,0x503F,readpacin0},
        {0x5040,0x507F,readpacin1},
        {0x5080,0x50BF,readpacin2},
        {-1,     -1,     NULL}
};

struct z80PortRead pacmanportread[] =
{
	{-1,	  -1,	  NULL}
};

static void intchoose(UINT16 port, UINT8 data, struct z80PortWrite *pPW)
{
        if (data==0xFA)
           introutine=0x00;
        else
           introutine=0x8D;
//        closegfx();
//        printf("Warning - writing %02X to port %02X\n",data,port);
//        exit(-1);
}

struct z80PortWrite pacmanportwrite[] =
{
        {0,0,intchoose},
	{-1,	-1,	NULL}
};

int loadpacmangfx()
{
        int x,y,c,d,p=0;
        unsigned char val;
        unsigned char temp[16];
        FILE *f=fopen("pacman.5e","rb");
        chars[0]=createbmp(256*8,8);
        buffer=createbmp(256,256);
                for (c=0;c<128;c++)
                {
                        temp[8]=getc(f);
                        temp[9]=getc(f);
                        temp[10]=getc(f);
                        temp[11]=getc(f);
                        temp[12]=getc(f);
                        temp[13]=getc(f);
                        temp[14]=getc(f);
                        temp[15]=getc(f);
                        temp[0]=getc(f);
                        temp[1]=getc(f);
                        temp[2]=getc(f);
                        temp[3]=getc(f);
                        temp[4]=getc(f);
                        temp[5]=getc(f);
                        temp[6]=getc(f);
                        temp[7]=getc(f);
//                        fread(temp,16,1,f);
                        p=0;
                        for (y=7;y>-1;y--)
                        {
                                val=temp[p++];
                                for (x=3;x>-1;x--)
                                {
                                        switch(val&0x11)
                                        {
                                                case 0:
                                                putpixel(chars[0],(c*8)+y,x,0);
                                                break;
                                                case 1:
                                                putpixel(chars[0],(c*8)+y,x,1);
                                                break;
                                                case 0x10:
                                                putpixel(chars[0],(c*8)+y,x,2);
                                                break;
                                                case 0x11:
                                                putpixel(chars[0],(c*8)+y,x,3);
                                                break;
                                        }
                                        val>>=1;
                                }
                        }
                        for (y=7;y>-1;y--)
                        {
                                val=temp[p++];
                                for (x=7;x>3;x--)
                                {
                                        switch(val&0x11)
                                        {
                                                case 0:
                                                putpixel(chars[0],(c*8)+y,x,0);
                                                break;
                                                case 1:
                                                putpixel(chars[0],(c*8)+y,x,1);
                                                break;
                                                case 0x10:
                                                putpixel(chars[0],(c*8)+y,x,2);
                                                break;
                                                case 0x11:
                                                putpixel(chars[0],(c*8)+y,x,3);
                                                break;
                                        }
                                        val>>=1;
                                }
                        }
                }
                fclose(f);
                f=fopen("pacman.5f","rb");
                for (c=128;c<256;c++)
                {
                        temp[8]=getc(f);
                        temp[9]=getc(f);
                        temp[10]=getc(f);
                        temp[11]=getc(f);
                        temp[12]=getc(f);
                        temp[13]=getc(f);
                        temp[14]=getc(f);
                        temp[15]=getc(f);
                        temp[0]=getc(f);
                        temp[1]=getc(f);
                        temp[2]=getc(f);
                        temp[3]=getc(f);
                        temp[4]=getc(f);
                        temp[5]=getc(f);
                        temp[6]=getc(f);
                        temp[7]=getc(f);
//                        fread(temp,16,1,f);
                        p=0;
                        for (y=7;y>-1;y--)
                        {
                                val=temp[p++];
                                for (x=3;x>-1;x--)
                                {
                                        switch(val&0x11)
                                        {
                                                case 0:
                                                putpixel(chars[0],(c*8)+y,x,0);
                                                break;
                                                case 1:
                                                putpixel(chars[0],(c*8)+y,x,1);
                                                break;
                                                case 0x10:
                                                putpixel(chars[0],(c*8)+y,x,2);
                                                break;
                                                case 0x11:
                                                putpixel(chars[0],(c*8)+y,x,3);
                                                break;
                                        }
                                        val>>=1;
                                }
                        }
                        for (y=7;y>-1;y--)
                        {
                                val=temp[p++];
                                for (x=7;x>3;x--)
                                {
                                        switch(val&0x11)
                                        {
                                                case 0:
                                                putpixel(chars[0],(c*8)+y,x,0);
                                                break;
                                                case 1:
                                                putpixel(chars[0],(c*8)+y,x,1);
                                                break;
                                                case 0x10:
                                                putpixel(chars[0],(c*8)+y,x,2);
                                                break;
                                                case 0x11:
                                                putpixel(chars[0],(c*8)+y,x,3);
                                                break;
                                        }
                                        val>>=1;
                                }
                        }
                }
                fclose(f);
}

int pacmaninit()
{
        FILE *f;
        printf("Loading Pacman ROMs\n");
        f=fopen("pacman.6e","rb");
        fread(ram,4096,1,f);
        fclose(f);
        f=fopen("pacman.6f","rb");
        fread(ram+0x1000,4096,1,f);
        fclose(f);
        f=fopen("pacman.6h","rb");
        fread(ram+0x2000,4096,1,f);
        fclose(f);
        f=fopen("pacman.6j","rb");
        fread(ram+0x3000,4096,1,f);
        fclose(f);
        loadpacmangfx();
        memset(&z80,0,sizeof(z80));
        z80.z80Base=ram;
        z80.z80IoRead=pacmanportread;
        z80.z80IoWrite=pacmanportwrite;
        z80.z80MemRead=pacmanread;
        z80.z80MemWrite=pacmanwrite;
	mz80SetContext(&z80);
	mz80reset();
	mz80GetContext(&z80);
	z80.z80intAddr=0x38;
	z80.z80nmiAddr=0x66;
	mz80SetContext(&z80);
        dipswitch=0;
        printf("Pacman loaded\n");
        return 0;
}

void pacmandraw()
{
        int x,y;
        int addr=0x4000;
        for (x=0;x<28;x++)
        {
                for (y=0;y<36;y++)
                {
                        blit(chars[0],buffer,ram[addr],0,x*8,y*8,8,8);
                        addr++;
                }
        }
        blit(buffer,screen,0,0,0,0,256,256);
}

void pacmanrun()
{
        while (!keys[KEY_ESC])
        {
                if (mz80exec(57000)!=0x80000000)
                {
                        printf("It crashed\n");
                        exit(-1);
                }
                if (intenable)
                   mz80int(introutine);
                pacmandraw();
        }
}