#include <stdio.h>
#include "gfx.h"
#include "mem.h"
#include "mz80.h"
#include "yaame.h"

int sound;
unsigned char vidcon,vidscroll,sounda,soundb,dipswitch;
PALETTE pal1,pal2;

UINT8 readvidcon(UINT32 addr, struct MemoryReadByte *crap)
{
        return vidcon;
}

UINT8 readscroll(UINT32 addr, struct MemoryReadByte *crap)
{
        return vidscroll;
}

UINT8 readsounda(UINT32 addr, struct MemoryReadByte *crap)
{
        return sounda;
}

UINT8 readsoundb(UINT32 addr, struct MemoryReadByte *crap)
{
        return soundb;
}

UINT8 readcontrol(UINT32 addr, struct MemoryReadByte *crap)
{
        unsigned char temp=0;
        if (keys[KEY_C])
           temp|=1;
        if (!keys[KEY_1])
           temp|=2;
        if (!keys[KEY_2])
           temp|=4;
        if (!keys[KEY_SPACE])
           temp|=16;
        if (!keys[KEY_RIGHT])
           temp|=32;
        if (!keys[KEY_LEFT])
           temp|=64;
        if (!keys[KEY_ALT])
           temp|=128;
        return temp;
}

UINT8 readdip(UINT32 addr, struct MemoryReadByte *crap)
{
        if (dipswitch)
        {
                dipswitch=0;
                return 0x80;
        }
        return 0;
}

static void writevidcon(UINT32 addr, UINT8 data, struct MemoryWriteByte *pMemWrite)
{
        vidcon=data;
        if (vidcon&2)
        {
                setpal(pal2);
        }
        else
        {
                setpal(pal1);
        }
}

static void writescroll(UINT32 addr, UINT8 data, struct MemoryWriteByte *pMemWrite)
{
        vidscroll=data;
}

static void writesounda(UINT32 addr, UINT8 data, struct MemoryWriteByte *pMemWrite)
{
//        int freq;
        sounda=data;
//        if (sound)
//        {
//                freq=sounda&0xF;
//                playnote(1,freq*100);
//                if (freq!=0xF)
//                   playnote(0,(44100*7)/(16-freq));
//                else
//                   stopnote(0);
//        }
}

static void writesoundb(UINT32 addr, UINT8 data, struct MemoryWriteByte *pMemWrite)
{
//        int freq;
        soundb=data;
//                freq=soundb&0xF;
//                playnote(1,freq*100);
//                if (freq!=0xF)
//                   playnote(1,(44100*7)/(16-freq));
//                else
//                   stopnote(1);
}

static void writecontrol(UINT32 addr, UINT8 data, struct MemoryWriteByte *pMemWrite)
{
}

static void writedip(UINT32 addr, UINT8 data, struct MemoryWriteByte *pMemWrite)
{
}

struct MemoryWriteByte phoenixwrite[] =
{
        {0,0x4000,writerom},
        {0x5000,0x5400,writevidcon},
        {0x5800,0x5C00,writescroll},
        {0x6000,0x6400,writesounda},
        {0x6800,0x6C00,writesoundb},
        {0x7000,0x7400,writecontrol},
        {0x7800,0x7C00,writedip},
        {-1,     -1,     NULL}
};

struct MemoryReadByte phoenixread[] =
{
        {0x5000,0x5400,readvidcon},
        {0x5800,0x5C00,readscroll},
        {0x6000,0x6400,readsounda},
        {0x6800,0x6C00,readsoundb},
        {0x7000,0x7400,readcontrol},
        {0x7800,0x7C00,readdip},
        {-1,     -1,     NULL}
};

struct z80PortRead phoenixportread[] =
{
	{-1,	  -1,	  NULL}
};

struct z80PortWrite phoenixportwrite[] =
{
	{-1,	-1,	NULL}
};

void phoenixpalette() {
//Pallete 1, Charset A
  pal1[0].r=0x00>>2;pal1[0].g=0x00>>2; pal1[0].b=0x00>>2; //black
  pal1[1].r=0x00>>2;pal1[1].g=0x00>>2; pal1[1].b=0x00>>2; //black
  pal1[2].r=0x00>>2;pal1[2].g=0xFF>>2; pal1[2].b=0xDB>>2; //cyan
  pal1[3].r=0x00>>2;pal1[3].g=0xFF>>2; pal1[3].b=0xDB>>2; //cyan

  pal1[4].r=0x00>>2;pal1[4].g=0x00>>2; pal1[4].b=0x00>>2; //black
  pal1[5].r=0xFF>>2;pal1[5].g=0xFF>>2; pal1[5].b=0x00>>2; //yellow
  pal1[6].r=0xFF>>2;pal1[6].g=0x00>>2; pal1[6].b=0x00>>2; //red
  pal1[7].r=0xDB>>2;pal1[7].g=0xDB>>2; pal1[7].b=0xDB>>2; //white

  pal1[8].r=0x00>>2;pal1[8].g=0x00>>2; pal1[8].b=0x00>>2; //black
  pal1[9].r=0xFF>>2;pal1[9].g=0xFF>>2; pal1[9].b=0x00>>2; //yellow
  pal1[10].r=0xFF>>2;pal1[10].g=0x00>>2; pal1[10].b=0x00>>2; //red
  pal1[11].r=0xDB>>2;pal1[11].g=0xDB>>2; pal1[11].b=0xDB>>2; //white

  pal1[12].r=0x00>>2;pal1[12].g=0x00>>2; pal1[12].b=0x00>>2; //black
  pal1[13].r=0xFF>>2;pal1[13].g=0xB6>>2; pal1[13].b=0xDB>>2; //pink
  pal1[14].r=0xFF>>2;pal1[14].g=0x00>>2; pal1[14].b=0xFF>>2; //purple
  pal1[15].r=0xFF>>2;pal1[15].g=0xFF>>2; pal1[15].b=0x00>>2; //yellow

  pal1[16].r=0x00>>2;pal1[16].g=0x00>>2; pal1[16].b=0x00>>2; //black
  pal1[17].r=0xFF>>2;pal1[17].g=0xB6>>2; pal1[17].b=0xDB>>2; //pink
  pal1[18].r=0xFF>>2;pal1[18].g=0x00>>2; pal1[18].b=0xFF>>2; //purple
  pal1[19].r=0xFF>>2;pal1[19].g=0xFF>>2; pal1[19].b=0x00>>2; //yellow

  pal1[20].r=0x00>>2;pal1[20].g=0x00>>2; pal1[20].b=0x00>>2; //black
  pal1[21].r=0xFF>>2;pal1[21].g=0xB6>>2; pal1[21].b=0xDB>>2; //pink
  pal1[22].r=0xFF>>2;pal1[22].g=0x00>>2; pal1[22].b=0xFF>>2; //purple
  pal1[23].r=0xFF>>2;pal1[23].g=0xFF>>2; pal1[23].b=0x00>>2; //yellow

  pal1[24].r=0x00>>2;pal1[24].g=0x00>>2; pal1[24].b=0x00>>2; //black
  pal1[25].r=0xDB>>2;pal1[25].g=0xDB>>2; pal1[25].b=0xDB>>2; //white
  pal1[26].r=0xFF>>2;pal1[26].g=0x00>>2; pal1[26].b=0xFF>>2; //purple
  pal1[27].r=0xFF>>2;pal1[27].g=0xFF>>2; pal1[27].b=0x00>>2; //yellow

  pal1[28].r=0x00>>2;pal1[28].g=0x00>>2; pal1[28].b=0x00>>2; //black
  pal1[29].r=0xFF>>2;pal1[29].g=0x00>>2; pal1[29].b=0xFF>>2; //purple
  pal1[30].r=0x00>>2;pal1[30].g=0xFF>>2; pal1[30].b=0x00>>2; //green
  pal1[31].r=0xDB>>2;pal1[31].g=0xDB>>2; pal1[31].b=0xDB>>2; //white
//Charset B
  pal1[32].r=0x00>>2;pal1[32].g=0x00>>2; pal1[32].b=0x00>>2; //black
  pal1[33].r=0xFF>>2;pal1[33].g=0x00>>2; pal1[33].b=0x00>>2; //red
  pal1[34].r=0x24>>2;pal1[34].g=0x24>>2; pal1[34].b=0xDB>>2; //blue
  pal1[35].r=0xDB>>2;pal1[35].g=0xDB>>2; pal1[35].b=0xDB>>2; //white

  pal1[36].r=0x00>>2;pal1[36].g=0x00>>2; pal1[36].b=0x00>>2; //black
  pal1[37].r=0xFF>>2;pal1[37].g=0x00>>2; pal1[37].b=0xFF>>2; //purple
  pal1[38].r=0x95>>2;pal1[38].g=0x95>>2; pal1[38].b=0xFF>>2; //blueish
  pal1[39].r=0xFF>>2;pal1[39].g=0xB6>>2; pal1[39].b=0x00>>2; //dark orange

  pal1[40].r=0x00>>2;pal1[40].g=0x00>>2; pal1[40].b=0x00>>2; //black
  pal1[41].r=0xB6>>2;pal1[41].g=0x24>>2; pal1[41].b=0xFF>>2; //dark purple
  pal1[42].r=0x00>>2;pal1[42].g=0xFF>>2; pal1[42].b=0x00>>2; //green
  pal1[43].r=0xFF>>2;pal1[43].g=0xB6>>2; pal1[43].b=0x00>>2; //dark orange

  pal1[44].r=0x00>>2;pal1[44].g=0x00>>2; pal1[44].b=0x00>>2; //black
  pal1[45].r=0x95>>2;pal1[45].g=0x95>>2; pal1[45].b=0xFF>>2; //blueish
  pal1[46].r=0xB6>>2;pal1[46].g=0x24>>2; pal1[46].b=0xFF>>2; //dark purple
  pal1[47].r=0xFF>>2;pal1[47].g=0x24>>2; pal1[47].b=0xB6>>2; //light purple

  pal1[48].r=0x00>>2;pal1[48].g=0x00>>2; pal1[48].b=0x00>>2; //black
  pal1[49].r=0xFF>>2;pal1[49].g=0x00>>2; pal1[49].b=0xFF>>2; //purple
  pal1[50].r=0x95>>2;pal1[50].g=0x95>>2; pal1[50].b=0xFF>>2; //blueish
  pal1[51].r=0x00>>2;pal1[51].g=0xFF>>2; pal1[51].b=0x00>>2; //green

  pal1[52].r=0x00>>2;pal1[52].g=0x00>>2; pal1[52].b=0x00>>2; //black
  pal1[53].r=0xFF>>2;pal1[53].g=0x00>>2; pal1[53].b=0xFF>>2; //purple
  pal1[54].r=0x95>>2;pal1[54].g=0x95>>2; pal1[54].b=0xFF>>2; //blueish
  pal1[55].r=0x00>>2;pal1[55].g=0xFF>>2; pal1[55].b=0x00>>2; //green

  pal1[56].r=0x00>>2;pal1[56].g=0x00>>2; pal1[56].b=0x00>>2; //black
  pal1[57].r=0xFF>>2;pal1[57].g=0x00>>2; pal1[57].b=0xFF>>2; //purple
  pal1[58].r=0x95>>2;pal1[58].g=0x95>>2; pal1[58].b=0xFF>>2; //blueish
  pal1[59].r=0x00>>2;pal1[59].g=0xFF>>2; pal1[59].b=0x00>>2; //green

  pal1[60].r=0x00>>2;pal1[60].g=0x00>>2; pal1[60].b=0x00>>2; //black
  pal1[61].r=0xFF>>2;pal1[61].g=0x00>>2; pal1[61].b=0xFF>>2; //purple
  pal1[62].r=0x95>>2;pal1[62].g=0x95>>2; pal1[62].b=0xFF>>2; //blueish
  pal1[63].r=0x00>>2;pal1[63].g=0xFF>>2; pal1[63].b=0x00>>2; //green

//Pallete 2 Charset A
  pal2[0].r=0x00>>2;pal2[0].g=0x00>>2; pal2[0].b=0x00>>2; //black
  pal2[1].r=0x24>>2;pal2[1].g=0x24>>2; pal2[1].b=0xDB>>2; //black
  pal2[2].r=0x00>>2;pal2[2].g=0xFF>>2; pal2[2].b=0xDB>>2; //cyan
  pal2[3].r=0x00>>2;pal2[3].g=0xFF>>2; pal2[3].b=0xDB>>2;//cyan

  pal2[4].r=0x00>>2;pal2[4].g=0x00>>2; pal2[4].b=0x00>>2; //black
  pal2[5].r=0xFF>>2;pal2[5].g=0xFF>>2; pal2[5].b=0x00>>2; //yellow
  pal2[6].r=0xFF>>2;pal2[6].g=0x00>>2; pal2[6].b=0x00>>2; //red
  pal2[7].r=0xDB>>2;pal2[7].g=0xDB>>2; pal2[7].b=0xDB>>2; //white

  pal2[8].r=0x00>>2;pal2[8].g=0x00>>2; pal2[8].b=0x00>>2; //black
  pal2[9].r=0xFF>>2;pal2[9].g=0xFF>>2; pal2[9].b=0x00>>2; //yellow
  pal2[10].r=0xFF>>2;pal2[10].g=0x00>>2; pal2[10].b=0x00>>2; //red
  pal2[11].r=0xDB>>2;pal2[11].g=0xDB>>2; pal2[11].b=0xDB>>2; //white

  pal2[12].r=0x00>>2;pal2[12].g=0x00>>2; pal2[12].b=0x00>>2; //black
  pal2[13].r=0xFF>>2;pal2[13].g=0xFF>>2; pal2[13].b=0x00>>2; //yellow
  pal2[14].r=0x00>>2;pal2[14].g=0xFF>>2; pal2[14].b=0x00>>2; //green
  pal2[15].r=0xFF>>2;pal2[15].g=0x00>>2; pal2[15].b=0xFF>>2; //purple

  pal2[16].r=0x00>>2;pal2[16].g=0x00>>2; pal2[16].b=0x00>>2; //black
  pal2[17].r=0xFF>>2;pal2[17].g=0xFF>>2; pal2[17].b=0x00>>2; //yellow
  pal2[18].r=0x00>>2;pal2[18].g=0xFF>>2; pal2[18].b=0x00>>2; //green
  pal2[19].r=0xFF>>2;pal2[19].g=0x00>>2; pal2[19].b=0xFF>>2; //purple

  pal2[20].r=0x00>>2;pal2[20].g=0x00>>2; pal2[20].b=0x00>>2; //black
  pal2[21].r=0xFF>>2;pal2[21].g=0xFF>>2; pal2[21].b=0x00>>2; //yellow
  pal2[22].r=0x00>>2;pal2[22].g=0xFF>>2; pal2[22].b=0x00>>2; //green
  pal2[23].r=0xFF>>2;pal2[23].g=0x00>>2; pal2[23].b=0xFF>>2; //purple

  pal2[24].r=0x00>>2;pal2[24].g=0x00>>2; pal2[24].b=0x00>>2; //black
  pal2[25].r=0xDB>>2;pal2[25].g=0xDB>>2; pal2[25].b=0xDB>>2; //white
  pal2[26].r=0xFF>>2;pal2[26].g=0x00>>2; pal2[26].b=0x00>>2; //red
  pal2[27].r=0xFF>>2;pal2[27].g=0x00>>2; pal2[27].b=0xFF>>2; //purple

  pal2[28].r=0x00>>2;pal2[28].g=0x00>>2; pal2[28].b=0x00>>2; //black
  pal2[29].r=0xFF>>2;pal2[29].g=0x00>>2; pal2[29].b=0xFF>>2; //purple
  pal2[30].r=0x00>>2;pal2[30].g=0xFF>>2; pal2[30].b=0x00>>2; //green
  pal2[31].r=0xDB>>2;pal2[31].g=0xDB>>2; pal2[31].b=0xDB>>2; //white
//Charset B
  pal2[32].r=0x00>>2;pal2[32].g=0x00>>2; pal2[32].b=0x00>>2; //black
  pal2[33].r=0xFF>>2;pal2[33].g=0x00>>2; pal2[33].b=0x00>>2; //red
  pal2[34].r=0x24>>2;pal2[34].g=0x24>>2; pal2[34].b=0xDB>>2; //blue
  pal2[35].r=0xDB>>2;pal2[35].g=0xDB>>2; pal2[35].b=0xDB>>2; //white

  pal2[36].r=0x00>>2;pal2[36].g=0x00>>2; pal2[36].b=0x00>>2; //black
  pal2[37].r=0xFF>>2;pal2[37].g=0x00>>2; pal2[37].b=0xFF>>2; //purple
  pal2[38].r=0x95>>2;pal2[38].g=0x95>>2; pal2[38].b=0xFF>>2; //blueish
  pal2[39].r=0xFF>>2;pal2[39].g=0xB6>>2; pal2[39].b=0x00>>2; //dark orange

  pal2[40].r=0x00>>2;pal2[40].g=0x00>>2; pal2[40].b=0x00>>2; //black
  pal2[41].r=0xB6>>2;pal2[41].g=0x24>>2; pal2[41].b=0xFF>>2; //dark purple
  pal2[42].r=0x00>>2;pal2[42].g=0xFF>>2; pal2[42].b=0x00>>2; //green
  pal2[43].r=0xFF>>2;pal2[43].g=0xB6>>2; pal2[43].b=0x00>>2; //dark orange

  pal2[44].r=0x00>>2;pal2[44].g=0x00>>2; pal2[44].b=0x00>>2; //black
  pal2[45].r=0x95>>2;pal2[45].g=0x95>>2; pal2[45].b=0xFF>>2; //blueish
  pal2[46].r=0xB6>>2;pal2[46].g=0x24>>2; pal2[46].b=0xFF>>2; //dark purple
  pal2[47].r=0xFF>>2;pal2[47].g=0x24>>2; pal2[47].b=0xB6>>2; //light purple

  pal2[48].r=0x00>>2;pal2[48].g=0x00>>2; pal2[48].b=0x00>>2; //black
  pal2[49].r=0x95>>2;pal2[49].g=0x95>>2; pal2[49].b=0xFF>>2; //blueish
  pal2[50].r=0xFF>>2;pal2[50].g=0x24>>2; pal2[50].b=0xB6>>2; //light purple
  pal2[51].r=0x00>>2;pal2[51].g=0xFF>>2; pal2[51].b=0x00>>2; //green

  pal2[52].r=0x00>>2;pal2[52].g=0x00>>2; pal2[52].b=0x00>>2; //black
  pal2[53].r=0x95>>2;pal2[53].g=0x95>>2; pal2[53].b=0xFF>>2; //blueish
  pal2[54].r=0xFF>>2;pal2[54].g=0x24>>2; pal2[54].b=0xB6>>2; //light purple
  pal2[55].r=0x00>>2;pal2[55].g=0xFF>>2; pal2[55].b=0x00>>2; //green

  pal2[56].r=0x00>>2;pal2[56].g=0x00>>2; pal2[56].b=0x00>>2; //black
  pal2[57].r=0x95>>2;pal2[57].g=0x95>>2; pal2[57].b=0xFF>>2; //blueish
  pal2[58].r=0xFF>>2;pal2[58].g=0x24>>2; pal2[58].b=0xB6>>2; //light purple
  pal2[59].r=0x00>>2;pal2[59].g=0xFF>>2; pal2[59].b=0x00>>2; //green
     
  pal2[60].r=0x00>>2;pal2[60].g=0x00>>2; pal2[60].b=0x00>>2; //black
  pal2[61].r=0x95>>2;pal2[61].g=0x95>>2; pal2[61].b=0xFF>>2; //blueish
  pal2[62].r=0xFF>>2;pal2[62].g=0x24>>2; pal2[62].b=0xB6>>2; //light purple
  pal2[63].r=0x00>>2;pal2[63].g=0xFF>>2; pal2[63].b=0x00>>2; //green

  return;
}


int loadphoenixgfx()
{
        FILE *f,*ff;
        int x,y,c;
        unsigned char byte1,byte2;
        f=fopen("ic39","rb");
        ff=fopen("ic40","rb");
        buffer=createbmp(208,312);
        for (c=0;c<256;c++)
        {
                for (y=7;y>-1;y--)
                {
                        bitplane[0][c][y]=getc(f);
                        bitplane[1][c][y]=getc(ff);
                }
        }
        fclose(ff);
        fclose(f);
        f=fopen("ic23","rb");
        ff=fopen("ic24","rb");
        for (c=0;c<256;c++)
        {
                for (y=7;y>-1;y--)
                {
                        bitplane[0][c+256][y]=getc(f);
                        bitplane[1][c+256][y]=getc(ff);
                }
        }
        fclose(ff);
        fclose(f);
        phoenixpalette();
        return 0;
}

int phoenixinit()
{
        FILE *f;
        printf("Loading Phoenix ROMs\n");
        loadrom("ic45",0,2048);
        loadrom("ic46",0x800,2048);
        loadrom("ic47",0x1000,2048);
        loadrom("ic48",0x1800,2048);
        loadrom("ic49",0x2000,2048);
        loadrom("ic50",0x2800,2048);
        loadrom("ic51",0x3000,2048);
        loadrom("ic52",0x3800,2048);
        printf("Loading Phoenix graphics\n");
        loadphoenixgfx();
        initz80(phoenixread,phoenixwrite,phoenixportread,phoenixportwrite);
        dipswitch=0;
        printf("Phoenix loaded\n");
        return 0;
}

int loadpleiadsgfx()
{
        FILE *f,*ff;
        int x,y,c;
        unsigned char byte1,byte2;
        f=fopen("ic39.bin","rb");
        ff=fopen("ic40.bin","rb");
        buffer=createbmp(208,312);
        for (c=0;c<256;c++)
        {
                for (y=7;y>-1;y--)
                {
                        bitplane[0][c][y]=getc(f);
                        bitplane[1][c][y]=getc(ff);
                }
        }
        fclose(ff);
        fclose(f);
        f=fopen("ic23.bin","rb");
        ff=fopen("ic24.bin","rb");
        for (c=0;c<256;c++)
        {
                for (y=7;y>-1;y--)
                {
                        bitplane[0][c+256][y]=getc(f);
                        bitplane[1][c+256][y]=getc(ff);
                }
        }
        fclose(ff);
        fclose(f);
        phoenixpalette();
        return 0;
}

int pleiadsinit()
{
        FILE *f;
        printf("Loading Pleiads ROMs\n");
        loadrom("ic47.r1",0,2048);
        loadrom("ic48.r2",0x800,2048);
        loadrom("ic47.bin",0x1000,2048);
        loadrom("ic48.bin",0x1800,2048);
        loadrom("ic51.r5",0x2000,2048);
        loadrom("ic50.bin",0x2800,2048);
        loadrom("ic53.r7",0x3000,2048);
        loadrom("ic52.bin",0x3800,2048);
        printf("Loading Pleiads graphics\n");
        loadpleiadsgfx();
        initz80(phoenixread,phoenixwrite,phoenixportread,phoenixportwrite);
        dipswitch=0;
        printf("Pleiads loaded\n");
        return 0;
}

void phoenixdraw()
{
        int y,x;
        int pos,pos2;
        unsigned char c;
        for (y = 0; y < 32; y++)
        {
                pos2 = 0x4800+32*(26-1)+y;
                for (x = 0; x < 26; x++)
                {
                        c = ram[pos2];
                        drawtile2(c+256,x<<3,(y<<3)-vidscroll,(c>>5)|8);
                        pos2-=32;
                }
        }
        for (y = 0; y < 32; y++)
        {
                pos = 0x4000+32*(26-1)+y;
                for (x = 0; x < 26; x++)
                {
                      c=ram[pos];
                      if (c)
                         drawtilemask2(c,x<<3,y<<3,c>>5);
                      pos -= 32;
                }
        }
        waitforsync();
        blit(buffer,screen,0,0,0,0,208,256);
}

void phoenixrun()
{
        FILE *f;
        while (!keys[KEY_ESC])
        {
                if (mz80exec(50000)!=0x80000000)
                {
                        printf("It crashed\n");
                        exit(-1);
                }
                dipswitch=0x80;
                phoenixdraw();
        }
        f=fopen("phoenix.dmp","wb");
        fwrite(ram,65536,1,f);
        fclose(f);
}
