#include "gfx.h"
#include <stdio.h>
#include "fm.h"

int sound=1;

int phoenixinit();
void phoenixrun();
int pleiadsinit();
int konginit();
int radarscopeinit();
void kongrun();
int siinit();
int si2init();
int eiinit();
void sirun();
int galaxianinit();
int warofbuginit();
int pacmanblinit();
void galaxianrun();

int game;

PALETTE yaamepal;

typedef struct YAAMEGAME
{
        unsigned char name[40];
        int (*init)();
        void (*run)();
} YAAMEGAME;

YAAMEGAME games[]=
{
        {"Phoenix",phoenixinit,phoenixrun},
        {"Pleiads",pleiadsinit,phoenixrun},
        {"Donkey Kong",konginit,kongrun},
        {"Radar Scope",radarscopeinit,kongrun},
        {"Space Invaders",siinit,sirun},
        {"Space Invaders Part II",si2init,sirun},
        {"Earth Invasion",eiinit,sirun},
        {"Galaxian",galaxianinit,galaxianrun},
        {"War Of The Bugs",warofbuginit,galaxianrun},
        {"Pac-Man (bootleg on Galaxian)",pacmanblinit,galaxianrun},
        {"",NULL,NULL}
};

int choosegame()
{
        int c=0,temp;
        while (1)
        {
                if (games[c].run)
                {
                        if (c<10)
                           printf("%i.%s\n",c,games[c].name);
                        else
                           printf("%c.%s\n",c-10+65,games[c].name);
                }
                else
                   break;
                c++;
        }
        temp=getch()-'0';
        if (temp>9)
        {
                temp-=7;
                if (temp>26)
                   temp-=32;
        }
        printf("game %i chosen\n",temp);
        return temp;
}

int main()
{
        game=choosegame();
        tomgfxinit();
        getpal(yaamepal);
        initkey();
        inittimer();
        chdir("roms");
        games[game].init();
        chdir("..");
        printf("Press a key to start");
        waitkey();
        if (initgfx(VESA2L,400,300,0,0))
           initgfx(VGA,256,240,0,0);
        setpal(yaamepal);
        inityaame();
        games[game].run();
        return 0;
}
